/********************************************

    cerror -  error    library  for
     cserver
    David Marquez Hernandez  - 2016
    TFG UOC - Redes de Computadores
    Profesor  - Jesús Arribi Vilela

*********************************************/

#include "cerror.h"

/*
    NAME:   cerror_show
    DESC:   Prints standard C error msg to screen and to log
    INPUT:  Nothing. (Uses C standard errno error management).
    OUTPUT: Nothing.
    NOTES:  Uses strerror_r which is the threadsafe version of strerror.
*/
void cerror_show(){

    char errorstring[MAXERRORLENGTH];
    char logline[MAXERRORLENGTH+256];

    if (!strerror_r(errno,errorstring,MAXERRORLENGTH)){ //strerror_r sucess
        printf("CSERVER PID: %d PPID: %d ERROR --> %s\n", getpid(),getppid(),errorstring);
        sprintf(logline,"PID: %d PPID: %d ERROR --> %s\n", getpid(),getppid(),errorstring);
        clogger_log(logline);
    } else {  //strerror_r failure
        printf("CSERVER PID: %d PPID: %d ERROR --> %s\n", getpid(),getppid(),"cerror-show(): Unable to get error string");
        sprintf(logline,"PID: %d PPID: %d ERROR --> %s\n", getpid(),getppid(),"cerror-show(): Unable to get error string");
        clogger_log(logline);
    }
}


/*
    NAME:   cerror_show_string
    DESC:   Prints error msg string to screen and to log
    INPUT:  String to show and log.
    OUTPUT: Nothing.
    NOTES:  Uses strerror_r which is the threadsafe version of strerror.
*/
void cerror_show_string(char *error_string){
    char logline[MAXERRORLENGTH];

    printf("CSERVER PID: %d PPID: %d ERROR --> %s\n", getpid(),getppid(),error_string);
    sprintf(logline,"PID: %d PPID: %d ERROR --> %s\n", getpid(),getppid(),error_string);
    clogger_log(logline);

}
