/********************************************

    chttp    -   http  library  for
     cserver
    David Marquez Hernandez  - 2016
    TFG UOC - Redes de Computadores
    Profesor  - Jesús Arribi Vilela

*********************************************/

#ifndef CHHTP_H_INCLUDED
#define CHHTP_H_INCLUDED

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <time.h>
#include <string.h>

#include "../clogger/clogger.h"
#include "../cerror/cerror.h"
#include "../cconfig/cconfig.h"


#define MAX_HEADER_SIZE 8192
#define MAX_HEADER_LINE_SIZE 1024
#define PAGE404 "<html><head><title>CSERVER: Can't find resource'</title></head><body>404 NOT FOUND</body></html>\r\n"
#define PAGE501 "<html><head><title>CSERVER: Method not implemented'</title></head><body>501 NOT IMPLEMENTED</body></html>\r\n"

typedef struct s_request_http_headers{
    char method[MAX_HEADER_LINE_SIZE];
    char resource[MAX_HEADER_LINE_SIZE];
    float version;
    char host[MAX_HEADER_LINE_SIZE];
    char user_agent[MAX_HEADER_LINE_SIZE];
    char accept[MAX_HEADER_LINE_SIZE];
    char accept_language[MAX_HEADER_LINE_SIZE];
    char accept_encoding[MAX_HEADER_LINE_SIZE];
    char connection[MAX_HEADER_LINE_SIZE];
    char cache_control[MAX_HEADER_LINE_SIZE];
} request_http_headers;

int read_http_request(int client_socket, request_http_headers *headers);
int reply_http_request(int client_socket,request_http_headers *headers,cconfig *config, char *client_ip);
int send_to_socket(int client_socket,char *string_to_send);
#endif // CHHTP_H_INCLUDED
