/********************************************

    clogger - logging  library  for
     cserver
    David Marquez Hernandez  - 2016
    TFG UOC - Redes de Computadores
    Profesor  - Jesús Arribi Vilela

*********************************************/

#include "clogger.h"


/* Var will be external to any other module */

int logging;

/*
    NAME:   clogger_init
    DESC:   Open syslog to write
    INPUT:  Nothing.
    OUTPUT: Always 0, syslog doesn't return anything.
*/

int clogger_init(void){

    if (logging>0) openlog("CSERVER",LOG_PID | LOG_CONS,LOG_USER);
    return 0;
}

/*
    NAME:   clogger_log
    DESC:   Logs mesage pointed by pointer message to syslog
    INPUT:  Pointer to string that will be logged.
    OUTPUT: Always 0, syslog doesn't return anything.
*/
int clogger_log(char *message){

    if (logging>0) syslog(LOG_USER,"%s",message);
    return 0;
}


/*
    NAME:   clogger_close
    DESC:   Closes syslog
    INPUT:  Nothing.
    OUTPUT: Always 0.
*/
int clogger_stop(void){
    if (logging>0) closelog();
    return 0;
}
